//+------------------------------------------------------------------+
//|                                                            1.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   3
//--- plot Label1
#property indicator_label1  "Open"
#property indicator_type1   DRAW_HISTOGRAM
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Label2
#property indicator_label2  "Close"
#property indicator_type2   DRAW_HISTOGRAM
#property indicator_color2  clrGreen
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Label3
#property indicator_label3  "Session"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
#property indicator_minimum 0
#property indicator_maximum 3
//--- indicator buffers
double Label1Buffer[],Label2Buffer[],Label3Buffer[];

input int StartHour=10;
input int StartMinute=0;
input int EndHour=14;
input int EndMinute=0;

struct SSes{
   datetime StartTime;
   datetime EndTime;
   int StartIndex;
   int EndIndex; 
};

SSes Sessions[];

int Count;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Label1Buffer);
   SetIndexBuffer(1,Label2Buffer);
   SetIndexBuffer(2,Label3Buffer);
   SetIndexEmptyValue(2,0.);
//---
   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
  {Comment("");
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   static bool flag=false;
   if(flag) return(rates_total);
   flag=true;
   int size=0;
   GetBars(StartHour,StartMinute,EndHour,EndMinute,Sessions,size);
   ArrayInitialize(Label1Buffer,0.);
   ArrayInitialize(Label2Buffer,0.);
   ArrayInitialize(Label3Buffer,0.);
   for(int i=0;i<size;i++)
     {Label1Buffer[Sessions[i].StartIndex]=2;
      Label2Buffer[Sessions[i].EndIndex]=1;
      int d=Sessions[i].StartIndex-Sessions[i].EndIndex;
      for(int j=Sessions[i].StartIndex;j>Sessions[i].EndIndex;j--)
        {double c=double(Sessions[i].StartIndex-j)/d;
         Label3Buffer[j]=2.-c;
        }
      //if(i==0) continue;
      //if(index[i][0]==index[i-1][0]) Alert(i);
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

void GetBars(int aStartHour,int aStartMinute,int aEndHour,int aEndMinute,SSes & aSessions[],int & aCount){

   aCount=(int)((Time[0]-Time[Bars-1])/86400);   
   ArrayResize(aSessions,aCount);
   aCount=0;

   datetime st=0;
   int si=0;
   
   
   bool p=TimeSession(aStartHour,aStartMinute,aEndHour,aEndMinute,Time[Bars-1]);
   
   for(int i=Bars-2;i>=0;i--){
      
      bool c=TimeSession(aStartHour,aStartMinute,aEndHour,aEndMinute,Time[i]);
      
      if(c && !p){ // 
         st=Time[i];
         si=i;
      }
      
      if(!c && p){ // 
      
         if(st!=0){
                  
            aSessions[aCount].StartTime=st;
            aSessions[aCount].EndTime=Time[i+1];
            aSessions[aCount].StartIndex=si;
            aSessions[aCount].EndIndex=i+1;
   
            aCount++;
            
            st=0;
         }
      }    
      
      p=c;
   }
      
   ArrayResize(aSessions,aCount);

}

bool TimeSession(int aStartHour,int aStartMinute,int aEndHour,int aEndMinute,datetime aTimeNow){
   int tStartTime=3600*aStartHour+60*aStartMinute;
   int tEndTime=3600*aEndHour+60*aEndMinute;
   datetime tTimeNow=aTimeNow-86400*(aTimeNow/86400);
      if(tStartTime<=tEndTime){
         if(tTimeNow>=tStartTime && tTimeNow<tEndTime){
            return(true);
         }
      }
      else{
         if(tTimeNow>=tStartTime || tTimeNow<tEndTime){
            return(true);
         }
      }
   return(false);
}